import AwaitedHandler from '../AwaitedHandler';
import AwaitedPath from '../AwaitedPath';
import AwaitedIterator from '../AwaitedIterator';
import { IHTMLSelectElementIsolate } from '../interfaces/isolate';
import { ISuperElement, ISuperNodeList, ISuperHTMLCollection } from '../interfaces/super';
import { IHTMLFormElement, IHTMLOptionsCollection, IValidityState, IHTMLOptionElement } from '../interfaces/official';
export declare const getState: (instance: IHTMLSelectElementIsolate) => IHTMLSelectElementIsolateProperties, setState: (instance: IHTMLSelectElementIsolate, properties: Partial<IHTMLSelectElementIsolateProperties>) => void;
export declare const awaitedHandler: AwaitedHandler<IHTMLSelectElementIsolate>;
export declare const awaitedIterator: AwaitedIterator<IHTMLSelectElementIsolate, ISuperElement>;
export default class HTMLSelectElementIsolate implements IHTMLSelectElementIsolate {
    get autocomplete(): Promise<string>;
    get autofocus(): Promise<boolean>;
    get disabled(): Promise<boolean>;
    get form(): IHTMLFormElement;
    get labels(): ISuperNodeList;
    get length(): Promise<number>;
    get multiple(): Promise<boolean>;
    get name(): Promise<string>;
    get options(): Promise<ISuperHTMLCollection> | IHTMLOptionsCollection;
    get required(): Promise<boolean>;
    get selectedIndex(): Promise<number>;
    get selectedOptions(): ISuperHTMLCollection;
    get size(): Promise<string> | Promise<number>;
    get type(): Promise<string>;
    get validationMessage(): Promise<string>;
    get validity(): Promise<IValidityState>;
    get value(): Promise<string> | Promise<number>;
    get willValidate(): Promise<boolean>;
    checkValidity(): Promise<boolean>;
    item(index: number): ISuperElement;
    namedItem(name: string): IHTMLOptionElement;
    reportValidity(): Promise<boolean>;
    [Symbol.iterator](): Iterator<ISuperElement>;
    [index: number]: ISuperElement;
}
export interface IHTMLSelectElementIsolateProperties {
    awaitedPath: AwaitedPath;
    awaitedOptions: any;
    createInstanceName: string;
    createIterableName: string;
    readonly autocomplete?: Promise<string>;
    readonly autofocus?: Promise<boolean>;
    readonly disabled?: Promise<boolean>;
    readonly form?: IHTMLFormElement;
    readonly labels?: ISuperNodeList;
    readonly length?: Promise<number>;
    readonly multiple?: Promise<boolean>;
    readonly name?: Promise<string>;
    readonly options?: Promise<ISuperHTMLCollection> | IHTMLOptionsCollection;
    readonly required?: Promise<boolean>;
    readonly selectedIndex?: Promise<number>;
    readonly selectedOptions?: ISuperHTMLCollection;
    readonly size?: Promise<string> | Promise<number>;
    readonly type?: Promise<string>;
    readonly validationMessage?: Promise<string>;
    readonly validity?: Promise<IValidityState>;
    readonly value?: Promise<string> | Promise<number>;
    readonly willValidate?: Promise<boolean>;
}
export declare const HTMLSelectElementIsolatePropertyKeys: string[];
export declare const HTMLSelectElementIsolateConstantKeys: never[];
