"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.HTMLOptGroupElementConstantKeys = exports.HTMLOptGroupElementPropertyKeys = exports.HTMLOptGroupElementGenerator = exports.nodeFactory = exports.awaitedHandler = exports.setState = exports.getState = void 0;
const AwaitedHandler_1 = __importDefault(require("../AwaitedHandler"));
const inspectInstanceProperties_1 = __importDefault(require("../inspectInstanceProperties"));
const StateMachine_1 = __importDefault(require("../StateMachine"));
const NodeFactory_1 = __importDefault(require("../NodeFactory"));
const HTMLElement_1 = require("./HTMLElement");
// tslint:disable:variable-name
_a = StateMachine_1.default(), exports.getState = _a.getState, exports.setState = _a.setState;
exports.awaitedHandler = new AwaitedHandler_1.default('HTMLOptGroupElement', exports.getState, exports.setState);
exports.nodeFactory = new NodeFactory_1.default(exports.getState, exports.setState, exports.awaitedHandler);
function HTMLOptGroupElementGenerator(HTMLElement) {
    return class HTMLOptGroupElement extends HTMLElement {
        constructor() {
            super();
            exports.setState(this, {
                createInstanceName: 'createHTMLOptGroupElement',
            });
        }
        // properties
        get disabled() {
            return exports.awaitedHandler.getProperty(this, 'disabled', false);
        }
        get label() {
            return exports.awaitedHandler.getProperty(this, 'label', false);
        }
        then(onfulfilled, onrejected) {
            return exports.nodeFactory.createInstanceWithNodePointer(this).then(onfulfilled, onrejected);
        }
        [Symbol.for('nodejs.util.inspect.custom')]() {
            return inspectInstanceProperties_1.default(this, exports.HTMLOptGroupElementPropertyKeys, exports.HTMLOptGroupElementConstantKeys);
        }
    };
}
exports.HTMLOptGroupElementGenerator = HTMLOptGroupElementGenerator;
exports.HTMLOptGroupElementPropertyKeys = [...HTMLElement_1.HTMLElementPropertyKeys, 'disabled', 'label'];
exports.HTMLOptGroupElementConstantKeys = [...HTMLElement_1.HTMLElementConstantKeys];
//# sourceMappingURL=HTMLOptGroupElement.js.map