import AwaitedPath from '../base/AwaitedPath';
import { IAbstractRange, IAttr, IAudioTrack, IAudioTrackList, IBlob, ICSSRule, ICSSRuleList, ICSSStyleDeclaration, ICSSStyleSheet, ICaretPosition, ICharacterData, IDOMImplementation, IDOMParser, IDOMRect, IDOMRectList, IDOMRectReadOnly, IDOMTokenList, IDocument, IDocumentFragment, IDocumentType, IElement, IFeaturePolicy, IFile, IFileList, IHTMLAnchorElement, IHTMLAreaElement, IHTMLAudioElement, IHTMLBRElement, IHTMLBaseElement, IHTMLBodyElement, IHTMLButtonElement, IHTMLCanvasElement, IHTMLCollection, IHTMLCollectionBase, IHTMLDListElement, IHTMLDataElement, IHTMLDataListElement, IHTMLDetailsElement, IHTMLDialogElement, IHTMLDirectoryElement, IHTMLDivElement, IHTMLDocument, IHTMLElement, IHTMLEmbedElement, IHTMLFieldSetElement, IHTMLFontElement, IHTMLFormControlsCollection, IHTMLFormElement, IHTMLFrameElement, IHTMLFrameSetElement, IHTMLHRElement, IHTMLHeadElement, IHTMLHeadingElement, IHTMLHtmlElement, IHTMLIFrameElement, IHTMLImageElement, IHTMLInputElement, IHTMLLIElement, IHTMLLabelElement, IHTMLLegendElement, IHTMLLinkElement, IHTMLMapElement, IHTMLMediaElement, IHTMLMetaElement, IHTMLMeterElement, IHTMLModElement, IHTMLOListElement, IHTMLObjectElement, IHTMLOptGroupElement, IHTMLOptionElement, IHTMLOptionsCollection, IHTMLParagraphElement, IHTMLParamElement, IHTMLPreElement, IHTMLProgressElement, IHTMLQuoteElement, IHTMLScriptElement, IHTMLSelectElement, IHTMLSlotElement, IHTMLSourceElement, IHTMLSpanElement, IHTMLStyleElement, IHTMLTableCaptionElement, IHTMLTableCellElement, IHTMLTableColElement, IHTMLTableElement, IHTMLTableRowElement, IHTMLTableSectionElement, IHTMLTemplateElement, IHTMLTextAreaElement, IHTMLTimeElement, IHTMLTitleElement, IHTMLTrackElement, IHTMLUListElement, IHTMLVideoElement, IHeaders, IImageBitmap, ILocation, IMediaError, IMediaKeys, IMediaList, IMediaStream, INamedNodeMap, INode, INodeList, IOffscreenCanvas, IRadioNodeList, IRange, IRequest, IResponse, ISelection, IShadowRoot, IStorage, IStyleSheet, IText, ITextTrack, ITextTrackCue, ITextTrackCueList, ITextTrackList, ITimeRanges, IValidityState, IVideoPlaybackQuality, IVideoTrack, IVideoTrackList, IXMLSerializer, IXPathEvaluator, IXPathExpression, IXPathResult } from '../base/interfaces/official';
import { ISuperDocument, ISuperElement, ISuperNode, ISuperNodeList, ISuperHTMLCollection, ISuperText, ISuperHTMLElement, ISuperStyleSheet } from '../base/interfaces/super';
export declare const setState: (instance: any, properties: Partial<any>) => void;
export declare function createAbstractRange<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IAbstractRange;
export declare function createAttr<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IAttr;
export declare function createAudioTrack<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IAudioTrack;
export declare function createAudioTrackList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IAudioTrackList;
export declare function createBlob<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IBlob;
export declare function createCSSRule<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICSSRule;
export declare function createCSSRuleList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICSSRuleList;
export declare function createCSSStyleDeclaration<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICSSStyleDeclaration;
export declare function createCSSStyleSheet<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICSSStyleSheet;
export declare function createCaretPosition<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICaretPosition;
export declare function createCharacterData<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ICharacterData;
export declare function createDOMImplementation<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMImplementation;
export declare function createDOMParser<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMParser;
export declare function createDOMRect<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMRect;
export declare function createDOMRectList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMRectList;
export declare function createDOMRectReadOnly<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMRectReadOnly;
export declare function createDOMTokenList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDOMTokenList;
export declare function createDocument<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDocument;
export declare function createDocumentFragment<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDocumentFragment;
export declare function createDocumentType<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IDocumentType;
export declare function createElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IElement;
export declare function createFeaturePolicy<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IFeaturePolicy;
export declare function createFile<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IFile;
export declare function createFileList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IFileList;
export declare function createHTMLAnchorElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLAnchorElement;
export declare function createHTMLAreaElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLAreaElement;
export declare function createHTMLAudioElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLAudioElement;
export declare function createHTMLBRElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLBRElement;
export declare function createHTMLBaseElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLBaseElement;
export declare function createHTMLBodyElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLBodyElement;
export declare function createHTMLButtonElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLButtonElement;
export declare function createHTMLCanvasElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLCanvasElement;
export declare function createHTMLCollection<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLCollection;
export declare function createHTMLCollectionBase<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLCollectionBase;
export declare function createHTMLDListElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDListElement;
export declare function createHTMLDataElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDataElement;
export declare function createHTMLDataListElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDataListElement;
export declare function createHTMLDetailsElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDetailsElement;
export declare function createHTMLDialogElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDialogElement;
export declare function createHTMLDirectoryElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDirectoryElement;
export declare function createHTMLDivElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDivElement;
export declare function createHTMLDocument<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLDocument;
export declare function createHTMLElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLElement;
export declare function createHTMLEmbedElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLEmbedElement;
export declare function createHTMLFieldSetElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFieldSetElement;
export declare function createHTMLFontElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFontElement;
export declare function createHTMLFormControlsCollection<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFormControlsCollection;
export declare function createHTMLFormElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFormElement;
export declare function createHTMLFrameElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFrameElement;
export declare function createHTMLFrameSetElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLFrameSetElement;
export declare function createHTMLHRElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLHRElement;
export declare function createHTMLHeadElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLHeadElement;
export declare function createHTMLHeadingElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLHeadingElement;
export declare function createHTMLHtmlElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLHtmlElement;
export declare function createHTMLIFrameElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLIFrameElement;
export declare function createHTMLImageElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLImageElement;
export declare function createHTMLInputElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLInputElement;
export declare function createHTMLLIElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLLIElement;
export declare function createHTMLLabelElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLLabelElement;
export declare function createHTMLLegendElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLLegendElement;
export declare function createHTMLLinkElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLLinkElement;
export declare function createHTMLMapElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLMapElement;
export declare function createHTMLMediaElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLMediaElement;
export declare function createHTMLMetaElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLMetaElement;
export declare function createHTMLMeterElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLMeterElement;
export declare function createHTMLModElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLModElement;
export declare function createHTMLOListElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLOListElement;
export declare function createHTMLObjectElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLObjectElement;
export declare function createHTMLOptGroupElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLOptGroupElement;
export declare function createHTMLOptionElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLOptionElement;
export declare function createHTMLOptionsCollection<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLOptionsCollection;
export declare function createHTMLParagraphElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLParagraphElement;
export declare function createHTMLParamElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLParamElement;
export declare function createHTMLPreElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLPreElement;
export declare function createHTMLProgressElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLProgressElement;
export declare function createHTMLQuoteElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLQuoteElement;
export declare function createHTMLScriptElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLScriptElement;
export declare function createHTMLSelectElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLSelectElement;
export declare function createHTMLSlotElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLSlotElement;
export declare function createHTMLSourceElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLSourceElement;
export declare function createHTMLSpanElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLSpanElement;
export declare function createHTMLStyleElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLStyleElement;
export declare function createHTMLTableCaptionElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableCaptionElement;
export declare function createHTMLTableCellElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableCellElement;
export declare function createHTMLTableColElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableColElement;
export declare function createHTMLTableElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableElement;
export declare function createHTMLTableRowElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableRowElement;
export declare function createHTMLTableSectionElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTableSectionElement;
export declare function createHTMLTemplateElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTemplateElement;
export declare function createHTMLTextAreaElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTextAreaElement;
export declare function createHTMLTimeElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTimeElement;
export declare function createHTMLTitleElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTitleElement;
export declare function createHTMLTrackElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLTrackElement;
export declare function createHTMLUListElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLUListElement;
export declare function createHTMLVideoElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHTMLVideoElement;
export declare function createHeaders<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IHeaders;
export declare function createImageBitmap<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IImageBitmap;
export declare function createLocation<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ILocation;
export declare function createMediaError<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IMediaError;
export declare function createMediaKeys<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IMediaKeys;
export declare function createMediaList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IMediaList;
export declare function createMediaStream<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IMediaStream;
export declare function createNamedNodeMap<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): INamedNodeMap;
export declare function createNode<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): INode;
export declare function createNodeList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): INodeList;
export declare function createOffscreenCanvas<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IOffscreenCanvas;
export declare function createRadioNodeList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IRadioNodeList;
export declare function createRange<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IRange;
export declare function createRequest<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IRequest;
export declare function createResponse<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IResponse;
export declare function createSelection<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISelection;
export declare function createShadowRoot<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IShadowRoot;
export declare function createStorage<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IStorage;
export declare function createStyleSheet<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IStyleSheet;
export declare function createText<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IText;
export declare function createTextTrack<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ITextTrack;
export declare function createTextTrackCue<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ITextTrackCue;
export declare function createTextTrackCueList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ITextTrackCueList;
export declare function createTextTrackList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ITextTrackList;
export declare function createTimeRanges<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ITimeRanges;
export declare function createValidityState<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IValidityState;
export declare function createVideoPlaybackQuality<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IVideoPlaybackQuality;
export declare function createVideoTrack<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IVideoTrack;
export declare function createVideoTrackList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IVideoTrackList;
export declare function createXMLSerializer<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IXMLSerializer;
export declare function createXPathEvaluator<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IXPathEvaluator;
export declare function createXPathExpression<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IXPathExpression;
export declare function createXPathResult<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): IXPathResult;
export declare function createSuperDocument<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperDocument;
export declare function createSuperElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperElement;
export declare function createSuperNode<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperNode;
export declare function createSuperNodeList<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperNodeList;
export declare function createSuperHTMLCollection<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperHTMLCollection;
export declare function createSuperText<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperText;
export declare function createSuperHTMLElement<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperHTMLElement;
export declare function createSuperStyleSheet<IAwaitedOptions = {}>(awaitedPath: AwaitedPath, awaitedOptions: IAwaitedOptions): ISuperStyleSheet;
